// Auto-generated. Do not edit!

// (in-package uwb_hardware_driver.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class AnchorScan {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.AnchorID = null;
      this.x = null;
      this.y = null;
      this.z = null;
      this.tdoa_of_anchors = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('AnchorID')) {
        this.AnchorID = initObj.AnchorID
      }
      else {
        this.AnchorID = [];
      }
      if (initObj.hasOwnProperty('x')) {
        this.x = initObj.x
      }
      else {
        this.x = [];
      }
      if (initObj.hasOwnProperty('y')) {
        this.y = initObj.y
      }
      else {
        this.y = [];
      }
      if (initObj.hasOwnProperty('z')) {
        this.z = initObj.z
      }
      else {
        this.z = [];
      }
      if (initObj.hasOwnProperty('tdoa_of_anchors')) {
        this.tdoa_of_anchors = initObj.tdoa_of_anchors
      }
      else {
        this.tdoa_of_anchors = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type AnchorScan
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [AnchorID]
    bufferOffset = _arraySerializer.int32(obj.AnchorID, buffer, bufferOffset, null);
    // Serialize message field [x]
    bufferOffset = _arraySerializer.float64(obj.x, buffer, bufferOffset, null);
    // Serialize message field [y]
    bufferOffset = _arraySerializer.float64(obj.y, buffer, bufferOffset, null);
    // Serialize message field [z]
    bufferOffset = _arraySerializer.float64(obj.z, buffer, bufferOffset, null);
    // Serialize message field [tdoa_of_anchors]
    bufferOffset = _arraySerializer.float64(obj.tdoa_of_anchors, buffer, bufferOffset, null);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type AnchorScan
    let len;
    let data = new AnchorScan(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [AnchorID]
    data.AnchorID = _arrayDeserializer.int32(buffer, bufferOffset, null)
    // Deserialize message field [x]
    data.x = _arrayDeserializer.float64(buffer, bufferOffset, null)
    // Deserialize message field [y]
    data.y = _arrayDeserializer.float64(buffer, bufferOffset, null)
    // Deserialize message field [z]
    data.z = _arrayDeserializer.float64(buffer, bufferOffset, null)
    // Deserialize message field [tdoa_of_anchors]
    data.tdoa_of_anchors = _arrayDeserializer.float64(buffer, bufferOffset, null)
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += 4 * object.AnchorID.length;
    length += 8 * object.x.length;
    length += 8 * object.y.length;
    length += 8 * object.z.length;
    length += 8 * object.tdoa_of_anchors.length;
    return length + 20;
  }

  static datatype() {
    // Returns string type for a message object
    return 'uwb_hardware_driver/AnchorScan';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '009660821c13f9d8c56a9f6b84c2e666';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # This is a message to hold the fixed anchors' (UWB sensors) information at known coordinates
    # and Time Difference of Arrival (TDOA) values.
    #
    # The indoor positioning systems developed using UWB signals include multiple sensors
    # that transmit UWB signals in an environment.
    #
    # Calculations such as position, anchor selection etc. are made by using TDOA measurements 
    # from these sensors and coordinate information of the sensors.
    #
    # With the defined AnchorScan message, it allows the publish of this information
    # from the sensors via any developed firmware.
    
    Header header               
    
    int32[] AnchorID                # ID of fixed sensors.
    
    float64[] x                     # x coordinates of fixed sensors respectively in meter
    float64[] y                     # y coordinates of fixed sensors respectively in meter
    float64[] z                     # z coordinates of fixed sensors respectively in meter
    
    float64[] tdoa_of_anchors       # TDOA values of UWB signals according to sensor with minimum ID.
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new AnchorScan(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.AnchorID !== undefined) {
      resolved.AnchorID = msg.AnchorID;
    }
    else {
      resolved.AnchorID = []
    }

    if (msg.x !== undefined) {
      resolved.x = msg.x;
    }
    else {
      resolved.x = []
    }

    if (msg.y !== undefined) {
      resolved.y = msg.y;
    }
    else {
      resolved.y = []
    }

    if (msg.z !== undefined) {
      resolved.z = msg.z;
    }
    else {
      resolved.z = []
    }

    if (msg.tdoa_of_anchors !== undefined) {
      resolved.tdoa_of_anchors = msg.tdoa_of_anchors;
    }
    else {
      resolved.tdoa_of_anchors = []
    }

    return resolved;
    }
};

module.exports = AnchorScan;
